package com.youvoiceit.shared.model;

import com.google.code.twig.annotation.Entity;
import com.google.code.twig.annotation.Parent;
import com.toolcafe.gwt.client.exception.ToolCafeInputException;
import com.toolcafe.gwt.shared.model.ILoadable;
import com.toolcafe.gwt.shared.model.USState;
import com.toolcafe.gwtstore.shared.model.IRole;
import com.toolcafe.gwtstore.shared.model.Person;
import com.toolcafe.gwtstore.shared.model.RoleType;

/**
 * An activist. Someone registered to take action on issues or add new actions to the system.
 * @author rick
 *
 */
@Entity(allocateIdsBy=10, kind="Activist")
public class Activist implements IRole, ILoadable {

	private static final long serialVersionUID = 1L;
	
	private String key;
	private ActionCategory[] actionCategories;
	/** The activist's country of residence */
	private String country;
	/** The activist's state of residence */
	private USState state;
	/** The activist's city of residence */
	private String city;
	/** The activist's postal code */
	private String postalCode;
	/** The activist's voting ward, if needed to determine a voting district */
	private String ward;
	/** The activist's voting district */
	private VotingDistrict votingDistrict;
	@Parent
	Person person;
	
	public Activist() { }

	@Override
	public void copyFrom(Object source, boolean deepCopy)
			throws ToolCafeInputException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void loadObject() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Person getPerson() {
		return person;
	}

	@Override
	public void setPerson(Person person) {
		this.person = person;
	}

	@Override
	public IRole createRole() {
		return new Activist();
	}

	@Override
	public RoleType getRoleType() {
		return RoleType.activist;
	}

	@Override
	public String getKey() {
		return key;
	}

	@Override
	public void setKey(String key) {
		this.key = key;
	}

	@Override
	public void setPersonKey(String key) {
		// TODO Auto-generated method stub
		
	}

	/**
	 * Get the action categories of interest to this activist
	 * @param actionCategories the actionCategories to set
	 */
	public void setActionCategories(ActionCategory[] actionCategories) {
		this.actionCategories = actionCategories;
	}

	/**
	 * Set the action categories of interest to this activist
	 * @return the actionCategories
	 */
	public ActionCategory[] getActionCategories() {
		return actionCategories;
	}

	/**
	 * @param country the country to set
	 */
	public void setCountry(String country) {
		this.country = country;
	}

	/**
	 * @return the country
	 */
	public String getCountry() {
		return country;
	}

	/**
	 * @param state the state to set
	 */
	public void setState(USState state) {
		this.state = state;
	}

	/**
	 * @return the state
	 */
	public USState getState() {
		return state;
	}

	/**
	 * @param city the city to set
	 */
	public void setCity(String city) {
		this.city = city;
	}

	/**
	 * @return the city
	 */
	public String getCity() {
		return city;
	}

	/**
	 * Set the voting ward. Non-null if required to determine a voting district.
	 * @param ward the ward to set
	 */
	public void setWard(String ward) {
		this.ward = ward;
	}

	/**
	 * Get the voting ward. Non-null if required to determine a voting district.
	 * @return the ward
	 */
	public String getWard() {
		return ward;
	}

	/**
	 * @param votingDistrict the votingDistrict to set
	 */
	public void setVotingDistrict(VotingDistrict votingDistrict) {
		this.votingDistrict = votingDistrict;
	}

	/**
	 * @return the votingDistrict
	 */
	public VotingDistrict getVotingDistrict() {
		return votingDistrict;
	}

	/**
	 * Set the postal code 
	 * @param postalCode the postalCode to set
	 */
	public void setPostalCode(String postalCode) {
		this.postalCode = postalCode;
	}

	/**
	 * Get the postal code 
	 * @return the postalCode
	 */
	public String getPostalCode() {
		return postalCode;
	}
	
}
