package com.youvoiceit.shared.model;

/** Jurisdiction type. This indicates the type of political jurisdiction over which an elected official
 * has authority. For example: city councilor's JurisdictionType = city, a state representative's
 * JurisdictionType = state, and a U.S. Senator's JurisdictionType = national  */
public enum JurisdictionType {
	city, state, national;
	
	/**
	 * Get the display string for the JurisdictionType
	 * @return the display string
	 */
	public String getDisplayStr() {
		String displayStr = null;
		JurisdictionTypeMessages msgs = JurisdictionTypeMessages.INSTANCE; 
		
		switch (this) {
			case city :
				displayStr = msgs.city();
				break;
			case state :
				displayStr = msgs.state();
				break;
			case national :
				displayStr = msgs.national();
				break;
		}
		
		return displayStr;
	}
}